Program Feladatsor_310;
(*
  Feladat:
    N aruhaz kinalata; Van-e olyan aruhaz, amelyben minden kaphato.
  Megoldas:
  0. Tetelek
     = Unio (milyen aruk kaphatok egyaltalan)
     + Eldontes (van-e olyan, amelyik kinalathalmaza azonos az unio-halmazzal)
     + Eldontes (ket halmaz azonossaga)
  1. Specifikacio:
     Be: N:Egesz, Aruhaz:(Nev x Aruk)^*, Nev=Szoveg, Aruk=Szoveg^*
     Ki: Van:Logikai
     Ef: HalmazFelsorolas(Aruhaz.Nev) [egyedi nevek] ES
         BARMELY i:[1,N]: HalmazFelsorolas(Aruhaz(i).Aruk) [egyedi arunev]
     Uf: Van = LETEZIK i:[1,N]: Aruhaz(i).Aruk=UNIO(j=1..N) Aruhaz(j).Aruk
*)
  Uses  Crt22;
  Const MaxN=25;
        MaxAru=50;
        NevHossz=10;
  Type  TNev=String[NevHossz];
        TAru=String[NevHossz];
        TAruk=Array [1..MaxAru] of TAru;
        TAruhaz=Record Nev:TNev; Db:Byte; Aruk:TAruk End;
        TAruhazak=Array [1..MaxN] of TAruhaz;
  Var   N:Integer;
        Aruhaz:TAruhazak;
        Van:Boolean;

  Procedure Listazas;
    Var i,j:Integer;
  Begin
    UjLap('Az ruhzak knlata',0{nem vr});
    For i:=1 to N do
    Begin
      Writeln(Aruhaz[i].Nev,' (',Aruhaz[i].Db,')');
      For j:=1 to Aruhaz[i].Db do
      Begin
        Write(Aruhaz[i].Aruk[j]:NevHossz,'');
      End;
      Writeln
    End;{For i}
  End;

  Procedure AdatBeolvasas;
    Var i,j:Integer;
        be:String;
  Begin
    (*
      Beolvass a specifiklt inputrl [l. a Crt22 unit lerst!]:
      Figyelem:
        ha a file-input hibs, akkor "vgtelen ciklusba" eshet...
    *)
    UjLap('Az ruhzak knlatnak beolvassa',0{nem vr});
    Repeat
      Write('ruhzak szma:');
      Readln(N);
    Until N in [1..MaxN];
    For i:=1 to N do
    Begin
      Writeln(i:2,'. ruhz neve s ruknlata ',
                  ' (Kln sorokban, utols utn res sor):');
      Repeat
        Write(' Neve:');
        Readln(Aruhaz[i].Nev);
      Until (Aruhaz[i].Nev>'') {ellenrizend lenne az egyedisg is!!!};
      j:=0; {ruk szma}
      Repeat
        Write(j+1:2,'. ru:');
        {$i-}
        {Input egy sora = egy ru}
        Readln(be);
        If be>'' then
        Begin
          Inc(j); Aruhaz[i].Aruk[j]:=be;
        End;
        {$i+}
      Until be='' {ellenrizend lenne az egyedisg is!!!};
      Aruhaz[i].Db:=j;
    End;

    {Ellenrz kirs a kpernyre:}
    KonzolOutput;
    Listazas;
    BillreVar;
    {Visszavlts az esetleges file-outputra:}
    FileOutput('');

  End;

  Function VanTejesKinalatuAruhaz:Boolean;
    Var i:Integer;
        osszes:TAruhaz; {ruk unioja}
    {Ef: osszes-be belefr az unio}

    Procedure HozzaVesz(Var o,
                       {Var a:csak a cmszerinti tvtel miatt} a:TAruhaz);
      Var i,j:Integer;
          aru:TAru;
    Begin
      For i:=1 to a.Db do
      Begin
        aru:=a.Aruk[i];
        j:=1;
        While (j<=o.Db) and (o.Aruk[j]<>aru) do Inc(j);
        If j>o.Db then
        Begin
          Inc(o.Db); o.Aruk[o.Db]:=aru;
        End;
      End;
    End;

    Function AzonosE(Var {hatkonysg miatt} o,a:TAruhaz):Boolean;
      Var i,j:Integer;
          aru:TAru;
          megJo:Boolean;
    Begin
      If o.Db=a.Db then
      Begin
        i:=1; megJo:=True;
        While (i<=a.Db) and megJo do
        Begin
          aru:=a.Aruk[i];
          j:=1;
          While (j<=o.Db) and (o.Aruk[j]<>aru) do Inc(j);
          megJo:=j<=o.Db;
          Inc(i);
        End;
        AzonosE:=megJo
      End
        Else
      Begin
        AzonosE:=False
      End;
    End;

  Begin
    UjLap('',0{nem vr});
    osszes.Nev:='Unio'; osszes.Db:=0; {nem tesszk fl, hogy N>0!!!}
    For i:=1 to N do
    Begin
      HozzaVesz(osszes,Aruhaz[i]);
    End;
    i:=1;
    While (i<=N) and not AzonosE(osszes,Aruhaz[i]) do Inc(i);
    VanTejesKinalatuAruhaz:=(i<=N);
  End;

  Procedure EredmenyKiiras;
  Begin
    (*
      Krs a specifiklt outputra.
      Azaz ha van outputfile specifiklva, akkor ttrs arra;
      klnben marad a konzoloutput.
    *)
    UjLap('Eredmny',0{billre vr});
    Writeln('Van-e mindent knl ruhz: ',Van,'.');
    BillreVar;
  End;

Begin
  {Adatbeolvass file-bl v. konzolrl:}
  AdatBeolvasas;
  {Feldolgozs:}
  Van:=VanTejesKinalatuAruhaz;
  {Kirs file-ba v. konzolra:}
  EredmenyKiiras;
End.